package classes;

import jakarta.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "Kurs")
public class Course
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "ID")
    private int id;

    @Column(name = "Name")
    private String name;

    @Column(name = "Semester")
    private int semester;

    @Column(name = "Typ")
    private String courseType;

    @Column(name = "SWS")
    private int sws;

    @Column(name = "ECTS")
    private double ects;

    @Column(name = "Prüfungstyp")
    private String examType;

    @Column(name = "Anrechnung")
    private Boolean isCredited;

    @ManyToOne(fetch = FetchType.LAZY)
    private CoursesOfStudy coursesOfStudy;

    public Course()
    {

    }

    public Course(String name, int semester, String courseType, int sws, double ects, String examType, Boolean isCredited)
    {
        this.name = name;
        this.semester = semester;
        this.courseType = courseType;
        this.sws = sws;
        this.ects = ects;
        this.examType = examType;
        this.isCredited = isCredited;
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Course course = (Course) o;
        return id == course.id;
    }

    @Override
    public int hashCode()
    {
        return Objects.hash(id);
    }

    public int getId()
    {
        return id;
    }

    public void setId(int id)
    {
        this.id = id;
    }

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public int getSemester()
    {
        return semester;
    }

    public void setSemester(int semester)
    {
        this.semester = semester;
    }

    public String getCourseType()
    {
        return courseType;
    }

    public void setCourseType(String courseType)
    {
        this.courseType = courseType;
    }

    public int getSws()
    {
        return sws;
    }

    public void setSws(int sws)
    {
        this.sws = sws;
    }

    public double getEcts()
    {
        return ects;
    }

    public void setEcts(double ects)
    {
        this.ects = ects;
    }

    public String getExamType()
    {
        return examType;
    }

    public void setExamType(String examType)
    {
        this.examType = examType;
    }

    public Boolean isCredited()
    {
        return isCredited;
    }

    public void setCredited(Boolean credited)
    {
        isCredited = credited;
    }

    public void setCoursesOfStudy(CoursesOfStudy coursesOfStudy)
    {
        this.coursesOfStudy = coursesOfStudy;
    }
}
